#ifndef __SSGM_H__
#define __SSGM_H__

/*****************************************************************************/
// ssgm.h
// header file for "ssgm.c"
// 2016/10/27
// Hyunsik Yi
/*****************************************************************************/

/*****************************************************************************/
// header files
/*****************************************************************************/


/*****************************************************************************/
// MACRO definition
/*****************************************************************************/
#define SSGM_DEVICE_NAME "/dev/scSSGM" // SSGM access path

#define MCP 	0
#define NCP 	1
#define SOP1 	2
#define SOP2 	3
#define SOP3 	4
#define SOP4 	5

#define ESC 0x1B


/*****************************************************************************/
// function prototypes
/*****************************************************************************/
char getch();
int ssgmOpenDevice();
void ssgmCloseDevice();
int ssgmGetReg(SSGM_PARAM *param);
int ssgmSetReg(SSGM_PARAM *param);
int ssgmGetRevision(unsigned int* val);
int ssgmGetBuildDate(unsigned int* val);
int ssgmGetSerialNum(unsigned int* val);
int ssgmGetControlReg(unsigned int* val);
int ssgmSetControlReg(unsigned int val);
int ssgmGetPulseCount(int pulse_type, unsigned int* val);
int ssgmGetPulseDuration(int pulse_type, unsigned int* val);
int ssgmSetPulseDuration(int pulse_type, unsigned int val);
int ssgmGetPulseEnableSts(unsigned int* val);
int ssgmSetPulseEnableSts(int pulse_type, int onoff);
int ssgmGetPulseOutputSource(unsigned int *pulse_source);
int ssgmSetPulseOutputSource(int pulse_type, int source);
int ssgmGetPulseHighTime(unsigned int *high_time);
int ssgmSetPulseHighTime(unsigned int high_time);
int ssgmGetSopDelayTime(int sop, unsigned int *delay_time);
int ssgmSetSopDelayTime(int sop, unsigned int delay_time);
#endif

