/*****************************************************************************/
// ssgm_ioctl.h
// 2016/10/27
// Hyunsik Yi
/*****************************************************************************/
#ifndef __SSGM_IOCTL_H__
#define __SSGM_IOCTL_H__


/*****************************************************************************/
// offset address
/*****************************************************************************/
/* production revision */
#define ADDR_PROD_REV		0x00
/* build date */
#define ADDR_BLD_DATE		0x04
/* serial number */
#define ADDR_SRL_NUM		0x08

/* timer register */
#define ADDR_TIMER_REG	0x0C

/* control register */
#define ADDR_CTRL_REG		0x10

/* int. mask */
#define ADDR_INT_MASK		0x14
/* int. status */
#define ADDR_INT_STS		0x18

/* pulse enable */
#define ADDR_PULSE_EN		0x1C
/* pulse source selection */
#define ADDR_PULSE_SEL	0x20

/* MCP duration */
#define ADDR_MCP_DUR		0x24
/* NCP duration */
#define ADDR_NCP_DUR		0x28
/* pulse high time */
#define ADDR_PULSE_HI		0x2C
/* SOP1 delay time */
#define ADDR_SOP1_DLY		0x30
/* SOP2 delay time */
#define ADDR_SOP2_DLY		0x34
/* SOP3 delay time */
#define ADDR_SOP3_DLY		0x38
/* SOP4 delay time */
#define ADDR_SOP4_DLY		0x3C

/* MCP pulse counter */
#define ADDR_MCP_CNT		0x40
/* NCP pulse counter */
#define ADDR_NCP_CNT		0x44
/* SOP1 pulse counter */
#define ADDR_SOP1_CNT		0x48
/* SOP2 pulse counter */
#define ADDR_SOP2_CNT		0x4C
/* SOP3 pulse counter */
#define ADDR_SOP3_CNT		0x50
/* SOP4 pulse counter */
#define ADDR_SOP4_CNT		0x54
/* NCP Gen Count */
#define ADDR_NCP_GEN_CNT	0x58
/* NCP Delay */
#define ADDR_NCP_DLY		0x5C


/*****************************************************************************/
// structures
/*****************************************************************************/
/* SSGM IO control */
typedef struct tagSsgmParam
{
	unsigned int addr;
	unsigned int val;
} SSGM_PARAM;


/*****************************************************************************/
// IOCTL command definistion for SSGM
/*****************************************************************************/
#define SSGM_IOCTL_MAGIC    't' 

// SDLC_ADDR_MODE operation
#define IOCTL_GET_SSGM_REG  _IO(SSGM_IOCTL_MAGIC, 1)
#define IOCTL_SET_SSGM_REG  _IO(SSGM_IOCTL_MAGIC, 2)

#endif 
